
package com.google.api.ads.adwords.jaxws.v201109.cm;

import java.util.List;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.ws.RequestWrapper;
import javax.xml.ws.ResponseWrapper;


/**
 * 
 *       Use this service to manage campaign-level criteria. A campaign-level negative
 *       criterion prevents the campaign's ads from showing on specific placements,
 *       specific keywords, demographics, and so on.
 *       
 *       Additionally, the service can be used to target criteria such as
 *       {@linkplain Criterion.Type#LOCATION location}, {@linkplain Criterion.Type#LANGUAGE language},
 *       {@linkplain Criterion.Type#CARRIER carrier}, {@linkplain Criterion.Type#PLATFORM platform}, and
 *       so on. The targeting criteria can be added using the Criterion Id listed in the appendix,
 *       e.g. <a href="http://code.google.com/apis/adwords/docs/appendix/platforms.html">
 *       http://code.google.com/apis/adwords/docs/appendix/platforms.html<a>
 *     
 * 
 * This class was generated by the JAX-WS RI.
 * JAX-WS RI 2.1.6
 * Generated source version: 2.1
 * 
 */
@WebService(name = "CampaignCriterionServiceInterface", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201109")
@XmlSeeAlso({
    ObjectFactory.class
})
public interface CampaignCriterionServiceInterface {


    /**
     * 
     *         Gets campaign criteria.
     *         
     *         @param serviceSelector the selector specifying the {@link CampaignCriterion}s to return.
     *         @return a list of campaign criteria
     *         @throws ApiException when there is at least one error with the request
     *       
     * 
     * @param serviceSelector
     * @return
     *     returns com.google.api.ads.adwords.jaxws.v201109.cm.CampaignCriterionPage
     * @throws ApiException_Exception
     */
    @WebMethod
    @WebResult(name = "rval", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201109")
    @RequestWrapper(localName = "get", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201109", className = "com.google.api.ads.adwords.jaxws.v201109.cm.CampaignCriterionServiceInterfaceget")
    @ResponseWrapper(localName = "getResponse", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201109", className = "com.google.api.ads.adwords.jaxws.v201109.cm.CampaignCriterionServiceInterfacegetResponse")
    public CampaignCriterionPage get(
        @WebParam(name = "serviceSelector", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201109")
        Selector serviceSelector)
        throws ApiException_Exception
    ;

    /**
     * 
     *         Adds, removes or updates campaign criteria.
     *         
     *         @param operations the operations to do
     *         @return the added campaign criteria (without any optional parts)
     *         @throws ApiException when there is at least one error with the request
     *       
     * 
     * @param operations
     * @return
     *     returns com.google.api.ads.adwords.jaxws.v201109.cm.CampaignCriterionReturnValue
     * @throws ApiException_Exception
     */
    @WebMethod
    @WebResult(name = "rval", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201109")
    @RequestWrapper(localName = "mutate", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201109", className = "com.google.api.ads.adwords.jaxws.v201109.cm.CampaignCriterionServiceInterfacemutate")
    @ResponseWrapper(localName = "mutateResponse", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201109", className = "com.google.api.ads.adwords.jaxws.v201109.cm.CampaignCriterionServiceInterfacemutateResponse")
    public CampaignCriterionReturnValue mutate(
        @WebParam(name = "operations", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201109")
        List<CampaignCriterionOperation> operations)
        throws ApiException_Exception
    ;

}
