
package com.google.api.ads.adwords.jaxws.v201109.cm;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for ReportDefinition.DateRangeType.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <p>
 * <pre>
 * &lt;simpleType name="ReportDefinition.DateRangeType">
 *   &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
 *     &lt;enumeration value="TODAY"/>
 *     &lt;enumeration value="YESTERDAY"/>
 *     &lt;enumeration value="LAST_7_DAYS"/>
 *     &lt;enumeration value="LAST_WEEK"/>
 *     &lt;enumeration value="LAST_BUSINESS_WEEK"/>
 *     &lt;enumeration value="THIS_MONTH"/>
 *     &lt;enumeration value="LAST_MONTH"/>
 *     &lt;enumeration value="ALL_TIME"/>
 *     &lt;enumeration value="CUSTOM_DATE"/>
 *     &lt;enumeration value="LAST_14_DAYS"/>
 *     &lt;enumeration value="LAST_30_DAYS"/>
 *     &lt;enumeration value="THIS_WEEK_SUN_TODAY"/>
 *     &lt;enumeration value="THIS_WEEK_MON_TODAY"/>
 *     &lt;enumeration value="LAST_WEEK_SUN_SAT"/>
 *   &lt;/restriction>
 * &lt;/simpleType>
 * </pre>
 * 
 */
@XmlType(name = "ReportDefinition.DateRangeType")
@XmlEnum
public enum ReportDefinitionDateRangeType {


    /**
     * 
     *                 Reports are generated for today only.
     *               
     * 
     */
    TODAY,

    /**
     * 
     *                 Reports are generated for yesterday only.
     *               
     * 
     */
    YESTERDAY,

    /**
     * 
     *                 Report are generated for the last 7 days not including today.
     *               
     * 
     */
    LAST_7_DAYS,

    /**
     * 
     *                 Reports are generated for the seven-day period starting with
     *                 previous Monday.
     *               
     * 
     */
    LAST_WEEK,

    /**
     * 
     *                 Reports are generated for the 5 day business week starting with previous
     *                 Monday.
     *               
     * 
     */
    LAST_BUSINESS_WEEK,

    /**
     * 
     *                 Reports are generated for all days in the current month.
     *               
     * 
     */
    THIS_MONTH,

    /**
     * 
     *                 Reports are generated for all days in the previous month.
     *               
     * 
     */
    LAST_MONTH,

    /**
     * 
     *                 Reports are generated for all available time range.
     *               
     * 
     */
    ALL_TIME,

    /**
     * 
     *                 Reports are generated for the date range specified by
     *                 {@link Selector#dateRange}.
     *               
     * 
     */
    CUSTOM_DATE,

    /**
     * 
     *                 Reports are generated for the last 14 days not including today.
     *               
     * 
     */
    LAST_14_DAYS,

    /**
     * 
     *                 Reports are generated for the last 30 days not including today.
     *               
     * 
     */
    LAST_30_DAYS,

    /**
     * 
     *                 Reports are generated for the period between the previous Sunday
     *                 and the current day.
     *               
     * 
     */
    THIS_WEEK_SUN_TODAY,

    /**
     * 
     *                 Reports are generated for the period between the previous Monday
     *                 and the current day.
     *               
     * 
     */
    THIS_WEEK_MON_TODAY,

    /**
     * 
     *                 Reports are generated for the seven-day period starting with
     *                 previous Sunday.
     *               
     * 
     */
    LAST_WEEK_SUN_SAT;

    public String value() {
        return name();
    }

    public static ReportDefinitionDateRangeType fromValue(String v) {
        return valueOf(v);
    }

}
